//
//  NEXMotion.h
//  NumberEightCompiled
//
//  Created by Oliver Kocsis on 20/06/2018.
//  Copyright © 2018 NumberEight Technologies Ltd. All rights reserved.
//
#pragma once

#import "NEMovement.h"
#import "NEXSensorItem.h"

NS_ASSUME_NONNULL_BEGIN

/**
 * Represents whether the device is moving or not moving.
 */
@interface NEXMovement : NEXSensorItem

/**
 * Default constructor.
 */
- (instancetype)init;

/**
 * Default constructor.
 */
+ (instancetype)new;

/**
 * Conversion copy constructor.
 * @param movement NEMovement to copy from.
 */
- (instancetype)initWithMovement:(NEMovement)movement;

/**
 * Conversion copy constructor.
 * @param movement NEMovement to copy from.
 * @param confidence An optional confidence level from 0.0 (min) to 1.0 (max).
 */
- (instancetype)initWithMovement:(NEMovement)movement confidence:(double)confidence;

/**
 * @param state State to assume.
 */
- (instancetype)initWithState:(NEMovementState)state;

/**
 * @param state State to assume.
 * @param confidence An optional confidence level from 0.0 (min) to 1.0 (max).
 */
- (instancetype)initWithState:(NEMovementState)state confidence:(double)confidence;

/**
 * Parse a string in serialized form.
 * @param string The serialized string, as generated by serialize()
 *
 * @return `nil` if unserialization failed.
 */
+ (instancetype _Nullable)unserializeWithString:(NSString*)string;

@property(nonatomic, readonly) NEMovement value DEPRECATED_ATTRIBUTE;

/**
 * Whether the device is moving or not moving.
 */
@property(nonatomic, readwrite) NEMovementState state;

+ (NSString*)stringFromState:(NEMovementState)state;

/**
 * @return A hash value representing the state of the Type.
 *          Can be used for checking equality.
 */
@property(nonatomic, readonly) NSUInteger hash;

/**
 * @return The name of the concrete value class extending NEXSensorItem.
 */
@property(nonatomic, readonly) NSString* type;

/**
 * @return A human-readable format of the held data.
 */
@property(nonatomic, readonly) NSString* description;

/**
 * @return A machine-readable format of the held data.  Returns `nil` if @p type is invalid, or if
 * serialization failed.
 */
- (NSString* _Nullable)serialize;

/**
 * Strict equality comparison.
 *
 * @see NEMovement_isEqual
 *
 * @param object Value to compare with.
 */
- (BOOL)isEqual:(id _Nullable)object;

/**
 * Convert the Objective-C class to a C-compatible struct.
 */
- (NEMovement)c_val;

@end
NS_ASSUME_NONNULL_END
